program apcb2htm;

uses crt,dos,sysutils;

var

  sql : boolean;
	
  year,month,day,dow : word;

  ilong,ftime_dir, ftime_dat,dirfile_linenumber : LongInt;

  sqldesc, tmpstring : AnsiString;

  fichier_dat, fichier_dir, fichier_html,
  fichier_header, fichier_err, fichier_inc, fichier_sql : text;

  afac,afac2,
  daystr,monthstr,yearstr,dateweb,datfile,
  dat_dirpath,
  dat_title,
  dat_background,
  dat_html,
  dat_ftp,
  dat_textlink,
  dat_weblink,
  webcolors,
  fichier_name,
  fichier_size,
  fichier_date,
  fichier_desc,
  fichier_descout,
  sql_name,
  sql_size,
  sql_date,
  sql_category,
  http,upper,lower,tmp_name,param2,param3 : string;

  i,len_desc,amp_exist,http_begin,http_end,upper_lower,dat_width,dat_header : byte;

  TYPE
    P_desc = ^desc;
    desc = record
                 linedesc : string;
                 nextline : P_desc;
               end;
    P_node = ^node;
    node = record
             file_name,
             file_size,
             file_date : string;
             next_desc : P_desc;
             next_node: P_node;
           end;

PROCEDURE UpCaseStr(Var s : String);
VAR
  i : Integer;
BEGIN
  FOR i := 1 TO Length(s) DO
    s[i] := UpCase(s[i]);
END;

PROCEDURE LowCaseStr(Var s : String);
VAR i, len : Integer;
BEGIN
  i := 0;
  len := Ord(s[0]);
  REPEAT
    Inc(i);
    IF i > len THEN
      BREAK;
    IF s[i] IN ['A'..'Z'] THEN
      inc(s[i], 32);
  UNTIL FALSE;
END;

FUNCTION Exist(sExp: STRING): BOOLEAN;
VAR s : TSearchRec;
BEGIN
  FINDFIRST(sExp,AnyFile,s);
  Exist:=(DOSError=0);
END;

PROCEDURE touch(fichier : string);
VAR F : Text;
    H,M,S,Hund : Word;
    DOW,Year,Month,Day : Word;
    FTime : LongInt;
    DT : DateTime;
BEGIN
  Assign(F,fichier);
  reset(f);
  GetTime(H,M,S,Hund);
  GetDate(Year,Month,Day,DOW);
  DT.Hour:=H;
  DT.Min:=M;
  DT.Sec:=S;
  DT.Year:=Year;
  DT.Month:=Month;
  DT.Day:=Day;
  PackTime(DT,FTime);
  SetFTime(F,FTime);
  close(f);
END;

PROCEDURE initfile(VAR tete : P_node);
BEGIN
 tete:=nil;
END;

function filevide(tete : P_node) : boolean;
BEGIN
 filevide:=tete=nil;
END;

PROCEDURE push_node(VAR tete : P_node);
var ptr_node : P_node;
    ptr_desc : P_desc;
BEGIN
   new(ptr_node);
   new(ptr_desc);
   IF tete=nil then tete:=ptr_node;
   ptr_node^.file_name:=fichier_name;
   ptr_node^.file_size:=fichier_size;
   ptr_node^.file_date:=fichier_date;
   ptr_node^.next_desc:=ptr_desc;
   ptr_desc^.linedesc:=fichier_descout;
   ptr_desc^.nextline:=nil;
   ptr_node^.next_node:=nil;
END;

PROCEDURE push_desc(VAR tete : P_desc);
var ptr_desc : P_desc;
BEGIN
   new(ptr_desc);
   IF tete=nil then tete:=ptr_desc;
   ptr_desc^.linedesc:= fichier_descout;
   ptr_desc^.nextline:= nil;
END;

PROCEDURE pop_desc(VAR tete : P_desc);
var ptr_desc : P_desc;
BEGIN
  ptr_desc:=tete;
  tete:=tete^.nextline;
  dispose(ptr_desc);
END;

PROCEDURE pop_node(VAR tete : P_node);
var ptr_node : P_node;
BEGIN
  ptr_node:=tete;
  tete:=tete^.next_node;
  dispose(ptr_node);
  WHILE tete^.next_desc<>nil DO
  BEGIN
    pop_desc(tete^.next_desc);
  END;
END;

PROCEDURE open_dat(namefile : string);
BEGIN
  IF exist(namefile) THEN
  BEGIN
    assign(fichier_dat,namefile);
    reset(fichier_dat);
    getftime(fichier_dat,ftime_dat);
  END
  ELSE
  BEGIN
    writeln(namefile,' doesnt exist, check your command line');
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - ',namefile,' doesnt exist, check your command line');
    close(fichier_err);
    halt;
  END;
  readln(fichier_dat,dat_dirpath);
  readln(fichier_dat,dat_title);
  readln(fichier_dat,dat_background);
  readln(fichier_dat,dat_width);
  readln(fichier_dat,dat_html);
  readln(fichier_dat,dat_ftp);
  readln(fichier_dat,dat_textlink);
  readln(fichier_dat,dat_weblink);
  readln(fichier_dat,dat_header);
  close(fichier_dat);
END;

PROCEDURE open_dir(namefile : string);
BEGIN
  IF exist(namefile) THEN
    BEGIN
      assign(fichier_dir,namefile);
      reset(fichier_dir);
      getftime(fichier_dir,ftime_dir);
    END
  ELSE
    BEGIN
      writeln(namefile,' stated in ',paramstr(1),' doesnt exist');
      assign(fichier_err,'error.txt');
      append(fichier_err);
      writeln(fichier_err,dateweb,' - ',namefile,' stated in ',paramstr(1),' doesnt exist');
      close(fichier_err);
      halt;
    END;

  {by default APCB2HTM like PCB2HTM always create a HTML file, but if
  you put 'noforce' as a parameter on command line, a date/time
  check will be done on the DAT file (touched at the end of program) and
  the PCBoard DIR file, the HTML file will only be created if DIR is
  newer than the DAT}

  IF (param2='noforce') or (param3='noforce') THEN
    IF (ftime_dat >= ftime_dir) THEN
    BEGIN
      writeln('No update on ',namefile,', I dont create a HTML page');
      close(fichier_dir);
      halt;
    END;
END;

PROCEDURE open_header(namefile : string);
BEGIN
  IF exist(namefile) THEN
  BEGIN
    assign(fichier_header,namefile);
    reset(fichier_header);
  END
  ELSE
  BEGIN
    writeln(namefile,' doesnt exist, get it from APCB2HTM.ZIP');
    close(fichier_dir);
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - ',namefile,' doesnt exist, get it from APCB2HTM.ZIP');
    close(fichier_err);
    halt;
  END;
END;

PROCEDURE open_inc(namefile : string);
BEGIN
  IF exist(namefile) THEN
  BEGIN
    assign(fichier_inc,namefile);
    reset(fichier_inc);
  END
  ELSE
  BEGIN
    writeln(namefile,' doesnt exist, get it from APCB2HTM.ZIP');
    close(fichier_dir);
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - ',namefile,' doesnt exist, get it from APCB2HTM.ZIP');
    close(fichier_err);
    halt;
  END;
END;

{ End of procedures and functions, start of program}

BEGIN
  clrscr;
  sql_name:='';
  sql_size:='';
  sql_date:='';
  sql_category:='';
  sqldesc:='';
  writeln('APCB2HTM v1.5 (12th June 2009)');
  writeln('(c) Emmanuel Roussin');
  writeln('Web     http://genesis8.free.fr/apcb2htm/');
  writeln('Email   roussin@noos.fr');
  writeln('compiled with Free Pascal v2.2.4, http://www.freepascal.org/');
  writeln;
  writeln('If you are using this program, let me know by email, thanks.');
  writeln;
  getdate(year, month, day, dow);
  str(year,yearstr);
  str(month,monthstr);
  str(day,daystr);
  IF length(monthstr)=1 THEN
    monthstr:='0'+monthstr;
  IF length(daystr)=1 THEN
    daystr:='0'+daystr;
  dateweb:=yearstr+monthstr+daystr;

  {managing command line parameter}

  datfile:=paramstr(1);
  param2:=paramstr(2);
  param3:=paramstr(3);
  lowcasestr(param2);
  lowcasestr(param3);
	IF (param2='sql') or (param3='sql') THEN
	  sql:=true
	ELSE
	  sql:=false;

  IF datfile='' THEN
  BEGIN
    writeln('No parameter on command line, I need a .DAT file');
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - no parameter on command line for APCB2HTM');
    close(fichier_err);
    halt;
  END;

  {managing DAT file given on command line}

  open_dat(datfile);

  {opening PCBoard DIR file}

  open_dir(dat_dirpath);

  {managing apcb2htm.cfg (was header.dat in v1.09 and before)}

  IF exist ('header.dat') THEN
  BEGIN
    assign(fichier_header,'header.dat');
    rename(fichier_header,'apcb2htm.cfg');
    writeln('HEADER.DAT has been renamed to APCB2HTM.CFG, see HISTORY.TXT');
  END;
  open_header('apcb2htm.cfg');


  {start to write SQL file}

	IF sql THEN
	BEGIN
    sql_category:=copy(dat_html,1,pos('.',dat_html)-1);
    IF exist('pcboard.sql') THEN
      BEGIN
        assign(fichier_sql,'pcboard.sql');
        append(fichier_sql);
      END
    ELSE
      BEGIN
        assign(fichier_sql,'pcboard.sql');
        rewrite(fichier_sql);
      END;
	END;

  {start to write HTML file}

  assign(fichier_html,dat_html);
  rewrite(fichier_html);
  writeln(fichier_html,'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">');
  writeln(fichier_html,'<html lang="en">');
  writeln(fichier_html,'<head>');
  readln(fichier_header,upper_lower);
  readln(fichier_header,webcolors);
  WHILE NOT eof(fichier_header) DO
  BEGIN
    readln(fichier_header,afac);
    writeln(fichier_html,afac);
  END;
  close(fichier_header);
  writeln(fichier_html,'<meta name="DC.Date.modified" scheme="W3CDTF" content="',year:0,'-',monthstr,'-',daystr,'">');
  writeln(fichier_html,'<meta name="description" content="',dat_title,'">');
  writeln(fichier_html,'<title>',dat_title,'</title>');
  writeln(fichier_html,'</head>');
  writeln(fichier_html);
  IF dat_background<>'NOBACK'THEN
    insert(dat_background,webcolors,length(webcolors)-1);
  writeln(fichier_html,webcolors);
  writeln(fichier_html,'<h1>',dat_title,'</h1>');
  writeln(fichier_html,'<p class="center">last update on ',daystr,'th ',monthstr,' ',year:0,'</p>');
  writeln(fichier_html,'<div id="archives">');
  writeln(fichier_html,'<table border="1" cellpadding="5" summary="List of files with name, size, date and description">');
  writeln(fichier_html,'<tr><th>Name</th><th>Size</th><th>Date</th><th>Description</th></tr>');
  writeln(fichier_html);

  {skipping useless lines at the start of the DIR file}

  FOR i:=1 to dat_header DO
    readln(fichier_dir,afac);

  {begin conversion of DIR to HTML}

  dirfile_linenumber:=0;
  WHILE NOT eof(fichier_dir) DO
  BEGIN
    inc(dirfile_linenumber);
    readln(fichier_dir,afac);
    fichier_name:=copy(afac,1,pos(' ',afac)-1);
    fichier_size:=trimleft(copy(afac,14,8));
    fichier_date:=copy(afac,24,8);
    fichier_desc:=copy(afac,34,length(afac)-33);
    fichier_descout:='';
    len_desc:=length(fichier_desc);
    FOR i:=1 TO len_desc DO
    BEGIN
      CASE fichier_desc[i] OF

      {translation of french/german/spanish accentued characters}

      '' : fichier_descout:=fichier_descout+'&eacute;';
      '' : fichier_descout:=fichier_descout+'&egrave;';
      '' : fichier_descout:=fichier_descout+'&ecirc;';
      '' : fichier_descout:=fichier_descout+'&euml;';
      '' : fichier_descout:=fichier_descout+'&ocirc;';
      '' : fichier_descout:=fichier_descout+'&ouml;';
      '' : fichier_descout:=fichier_descout+'&ucirc;';
      '' : fichier_descout:=fichier_descout+'&uuml;';
      '' : fichier_descout:=fichier_descout+'&ccedil;';
      '' : fichier_descout:=fichier_descout+'&icirc;';
      '' : fichier_descout:=fichier_descout+'&aacute;';
      '' : fichier_descout:=fichier_descout+'&agrave;';
      '' : fichier_descout:=fichier_descout+'&auml;';

      {translation of other characters}

      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'&brvbar;';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'&brvbar;';

      {HTML dislike < > " & }

      '<' : fichier_descout:=fichier_descout+'&lt;';
      '>' : fichier_descout:=fichier_descout+'&gt;';
      '"' : fichier_descout:=fichier_descout+'&quot;';
      '&' : fichier_descout:=fichier_descout+'&amp;';

      ELSE
        fichier_descout:=fichier_descout+fichier_desc[i];
      END;
    END;
		
    {now looking for a http address to transform into a web link}

    http_begin:=pos('http://',fichier_descout);
    IF http_begin>0 THEN
    BEGIN
      afac2:=copy(fichier_descout,http_begin,length(fichier_descout)-http_begin+1);
      http_end:=pos(' ',afac2);
      IF http_end=0 THEN http_end:=length(afac2)+1;
      http:=copy(afac2,1,http_end-1);
      insert('</a>',fichier_descout,http_end+length(fichier_descout)-length(afac2));
      insert('<a href="'+http+'">',fichier_descout,http_begin);
    END;

    {now we write the description line to HTML file}

    IF afac[1]=' ' THEN
  		BEGIN
        {line with only a part of description}
        IF fichier_desc='' THEN
          {empty line of description}
          BEGIN
            writeln(fichier_html);
            sqldesc:=sqldesc+'<br>'+'<br>';
          END
        ELSE
          {line of description not empty}
          BEGIN
            writeln(fichier_html,fichier_descout);
            sqldesc:=sqldesc+fichier_descout+'<br>';
          END;
  		END
    ELSE
      {line with a file name, size, date and first line of description}
      BEGIN

        lower:=fichier_name;
        lowcasestr(lower);
        upper:=fichier_name;
        upcasestr(upper);

        {checking for & in file name, replace with &amp; if any}

        tmp_name:=lower;
        amp_exist:=pos('&',tmp_name);
        IF amp_exist>0 THEN
          lower:=copy(tmp_name,1,amp_exist-1)+'&amp;'+copy(tmp_name,amp_exist+1,length(tmp_name)-amp_exist);
        tmp_name:=upper;
        amp_exist:=pos('&',tmp_name);
        IF amp_exist>0 THEN
          upper:=copy(tmp_name,1,amp_exist-1)+'&amp;'+copy(tmp_name,amp_exist+1,length(tmp_name)-amp_exist);

        IF dirfile_linenumber>1 THEN
        {end of a file in the DIR file}
        BEGIN
          {first we double the ' in the SQL script then we write the INSERT line}
					
					IF sql THEN
					BEGIN
            tmpstring:=sqldesc;
            sqldesc:='';
            FOR ilong:=1 TO length(tmpstring) DO
            BEGIN
              IF tmpstring[ilong]=chr(39) THEN
                sqldesc:=sqldesc+chr(39)+chr(39)
              ELSE
                sqldesc:=sqldesc+tmpstring[ilong];
            END;
            {strip last <br>

            sqldesc:=copy(sqldesc,1,lenght(sqldesc-4));
            }
            sqldesc:='INSERT INTO `pcboard` VALUES ('+chr(39)+sql_category+chr(39)+','+chr(39)+sql_name+chr(39)+','+chr(39)+sql_size+chr(39)+','+chr(39)+sql_date+chr(39)+','+chr(39)+sqldesc+chr(39)+');';
            writeln(fichier_sql,sqldesc);
            sqldesc:='';
          END;
          writeln(fichier_html,'</pre></td></tr>');
          writeln(fichier_html);
        END;

        IF upper_lower=0 THEN
          write(fichier_html,'<tr><td><a href="',dat_ftp,lower,'">',lower,'</a></td>')
        ELSE
          write(fichier_html,'<tr><td><a href="',dat_ftp,upper,'">',lower,'</a></td>');

        writeln(fichier_html,'<td>',fichier_size,'</td><td>',fichier_date,'</td><td>');
        writeln(fichier_html,'<pre>',fichier_descout);
				IF sql THEN
				BEGIN
          sqldesc:=sqldesc+fichier_descout+'<br>';
          sql_name:=fichier_name;
          sql_size:=fichier_size;
          sql_date:=fichier_date;
				END;
      END; {end IF afac[1]=' ' ELSE}
  END; {end while}
  close(fichier_dir);
	
  {dirty programming, duplicated code}

  IF sql THEN
	BEGIN
    tmpstring:=sqldesc;
    sqldesc:='';
    FOR i:=1 TO length(tmpstring) DO
    BEGIN
      IF tmpstring[i]=chr(39) THEN
        sqldesc:=sqldesc+chr(39)+chr(39)
      ELSE
        sqldesc:=sqldesc+tmpstring[i];
    END;
    sqldesc:='INSERT INTO `pcboard` VALUES ('+chr(39)+sql_category+chr(39)+','+chr(39)+sql_name+chr(39)+','+chr(39)+sql_size+chr(39)+','+chr(39)+sql_date+chr(39)+','+chr(39)+sqldesc+chr(39)+');';
    writeln(fichier_sql,sqldesc);
	  sqldesc:='';
	END;

  writeln(fichier_html,'</pre></td></tr>');
  writeln(fichier_html,'</table>');
  writeln(fichier_html,'</div>');
  writeln(fichier_html,'<br><p>Go back to <a href="',dat_weblink,'">',dat_textlink,'</a></p>');

  open_inc('include.cfg');
  WHILE not eof(fichier_inc) DO
  BEGIN
   readln(fichier_inc,fichier_descout);
   writeln(fichier_html,fichier_descout);
  END;
  close(fichier_inc);
  writeln(fichier_html,'<p>HTML page created by <a href="http://genesis8.free.fr/apcb2htm/">APCB2HTM v1.5</a></p>');
  writeln(fichier_html,'</body>');
  writeln(fichier_html,'</html>');
  close(fichier_html);
  IF sql THEN
	BEGIN
    close(fichier_sql);
	END;
  touch(paramstr(1));
END.
